/********************************************************\
|*                                                      *|
|*   Program:              WinVi                        *|
|*   Author:               Raphael Molle                *|
|*   Compiler:             several (w/ WIN32 support)   *|
|*   --------------------- --------------------------   *|
|*    Copyright 1994-2000 by Raphael Molle, Berlin     *|
|*    Copyleft by GPL     See file COPYING for more    *|
|*                         info about terms of use      *|
|*                                                      *|
\********************************************************/

/* revision log:
 *		3-Dec-2000	first publication of source code
 */

#include <windows.h>
#include "WinVi.h"
#include "Page.h"
#include "Paint.h"
#include "Colors.h"
#include "Status.h"
#include "ToolBar.h"

/*WinVi.h:*/
MODEENUM Mode;
UINT	 Language;
BOOL	 HexEditMode, TfForward, TfIsFind, ReplaceSingle;
BOOL	 Interruptable, FullRowExtend;
UINT	 Interrupted, CmdFirstChar, Number;
int		 TextHeight;  /*screen line y difference in pixels*/
LONG	 FirstVisible;/*line numbr (starting at 0) for bitmap alignment*/
COLORREF TextColor;
HCURSOR	 hcurCurrent, hcurArrow, hcurIBeam, hcurHourGlass, hcurSizeNwSe;
HFONT	 TextFont, HexFont;
HINST	 hInst;
HWND	 hwndMain, hwndCmd, hwndErrorParent;
WORD	 WinVersion;
LPCSTR	 CurrFile;
BOOL	 IsAltFile, Unsafe, CommandWithExclamation, CaretActive;
BOOL	 MouseActivated, BreakLineFlag, ShowMatchFlag;
BOOL	 ReadOnlyFlag, AutoRestoreFlag, AutoIndentFlag, AutoWriteFlag;
BOOL	 IgnoreCaseFlag, WrapScanFlag, TerseFlag, DefaultInsFlag;
BOOL	 DefaultTmpFlag, QuitIfMoreFlag, WrapPosFlag;
BOOL	 ListFlag, NumberFlag, HexNumberFlag, FullRowFlag;
BOOL	 ViewOnlyFlag;	/*view-only=restrictive read-only w/o editing*/
BOOL	 ReadOnlyFile;	/*read-only for this file only*/
COLUMN	 CurrCol;		/*aspired pixel position in logical line*/
ULONG	 CurrColumn;	/*displayed character offset within line (for status)*/
ULONG	 LinesInFile, SelectCount;
int		 CurrX, CurrLine;
int		 MaxScroll, Disabled;
char	 FileName[260];
LPSTR	 TmpDirectory, Tags;
UINT	 CharSet;	/*0=Ansi, 1=Pc*/
BOOL	 Indenting;
BOOL	 RefreshBitmap;
char	 BitmapFilename[260];
BOOL	 DlgResult;

/*Page.h:*/
LPPAGE	 FirstPage, LastPage;
POSITION ScreenStart, CurrPos;
PLINEINFO LineInfo, FirstScreenLine;
POSITION SelectStart;
ULONG	 SelectBytePos;

/*Paint.h:*/
COLORREF SelTextColor, SelBkgndColor;
char	 NumLock[10], CapsLock[10];

/*Colors.h:*/
COLORREF TextColor, BackgroundColor;
WORD	 wUseSysColors;		/*1:Bg, 2:Fg, 4:SelBg, 8:SelFg*/

/*Status.h:*/
STATUSFIELD	StatusFields[8];
int			StatusTextHeight;

/*ToolBar.h:*/
HFONT	TooltipFont;
int		yButtonOffset, nToolbarHeight;

