/********************************************************\
|*                                                      *|
|*   Program:              WinVi                        *|
|*   Author:               Raphael Molle                *|
|*   Compiler:             several (w/ WIN32 support)   *|
|*   --------------------- --------------------------   *|
|*    Copyright 1994-2000 by Raphael Molle, Berlin     *|
|*    Copyleft by GPL     See file COPYING for more    *|
|*                         info about terms of use      *|
|*                                                      *|
\********************************************************/

/* revision log:
 *		3-Dec-2000	first publication of source code
 *					this file is not in use yet
 */

#include <Windows.h>
#include <malloc.h>
#include "resource.h"
#include "WinVi.h"
#include "Map.h"

PMAP FirstMapping=NULL, NewMappings=NULL;

BOOL LoadMappings(VOID)
{
	return (FALSE);
}

BOOL SaveMappings(VOID)
{
	return (FALSE);
}

BOOL InitMappings(VOID)
{
	return (LoadMappings());
}

VOID TermMappings(VOID)
{
}

VOID FreeMappings(PMAP Tree)
{
	while (Tree != NULL) {
		PMAP ToDel = Tree;

		Tree = Tree->Next;
		if (ToDel->InputMatch	!= NULL) free(ToDel->InputMatch);
		if (ToDel->Name			!= NULL) free(ToDel->Name);
		if (ToDel->InputDisplay	!= NULL) free(ToDel->InputDisplay);
		if (ToDel->Replace		!= NULL) free(ToDel->Replace);
		free(ToDel);
	}
}

BOOL MapCallback(HWND hDlg, UINT uMsg, WPARAM wPar, LPARAM lPar)
{	HWND ListBox;

	(VOID)lPar;		/*parameter never used*/
	switch (uMsg) {
		case WM_INITDIALOG:
			ListBox = GetDlgItem(hDlg, IDC_MACROLIST);
			if (ListBox) {
				for (NewMappings = FirstMapping;
					 NewMappings != NULL;
					 NewMappings = NewMappings->Next)
				   SendMessage(ListBox, LB_ADDSTRING,
				   			   0, (LPARAM)(LPSTR)NewMappings->Name);
				if (FirstMapping != NULL) {
					SetDlgItemText(hDlg, IDC_MACRONAME,
								   FirstMapping->Name);
					SetDlgItemText(hDlg, IDC_MACROINPUT,
								   FirstMapping->InputDisplay);
					SetDlgItemText(hDlg, IDC_MACROREPLACE,
								   FirstMapping->Replace);
				}
			}
			break;

		case WM_COMMAND:
			switch (COMMAND) {
				case IDOK:
				case ID_APPLY:
				case IDC_STORE:
					FreeMappings(FirstMapping);
					FirstMapping = NewMappings;
					NewMappings = NULL;
					DlgResult = TRUE;
					if (COMMAND == IDC_STORE) SaveMappings();
					if (COMMAND != IDOK) break;
					/*FALLTHROUGH*/
				case IDCANCEL:
					EndDialog(hDlg, 0);
					break;
			}
			break;

		default:
			return (FALSE);
	}
	return (TRUE);
}
